/* This program is free software: you can redistribute it and/or modify
 *
 * Copyright (C) 2014 Stefan Canzar, Sandro Andreotti
 *
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include<Parameters.h>

namespace Parameters
{
  ReadType mode = PAIRED_END;

  FakeMode fake_mode = FAKE_NONE;

  ///the read lenght in the experimental setup
  //UInt read_length_global = 36;
  //UInt read_length_global = 100;
  UInt read_length_global = 75;

  ///the gap length for paired reads in the experimental setup
  //UInt insert_size_global = 250;

  //UInt insert_size_global = 232.81; //75_40 dataset
  //double s_dev = 22.16; //75_40 dataset

  //UInt insert_size_global = 263.39; //100_40 dataset
  //double s_dev = 25.60; //100_40 dataset



  //UInt insert_size_global = 232.86;
  //UInt insert_size_global = 110;
  //UInt insert_size_global = 225;
  
  //UInt insert_size_global = 235.80; // 75_4mio_min_2_max_8 dataset
  //double s_dev = 32.08; // 75_4mio_min_2_max_8 dataset

  UInt insert_size_global = 236.31; // 75_2mio_min_2_max_8 dataset
  double s_dev = 35.76; // 75_2mio_min_2_max_8 dataset

  //UInt insert_size_global = 235.52; // 75_8mio_min_2_max_8 dataset
  //double s_dev = 30.60; // // 75_8mio_min_2_max_8 dataset
  
  ///the gap length for paired reads in the experimental setup
  //double s_dev = 25.0;
  
    ///the alpha value used for probability estimations (the RPKM value assumed for a transcript)
  float alpha_global = 1.0;

  ///the number of reads/fragments in million in the experimental setup
  double M_global = 40.0;

  ///whether we perform de novo Inference
  bool de_novo_inference = true;

  bool weights = false;

  float lower_percentile = 0.05;
  float upper_percentile = 0.95;
  float theta = 50;

  bool pw_lin = false;
  bool quad_error = false;
  float epsilon = 0.01;

  double pseudoCount = 1.;
  int normCutoff = 0;


  UInt endSpace = 1;

  UInt max_nof_exskip = -1u; //-1u = no limit

  bool penaltyUncov = false; //penalize transcripts with uncovered junctions

  bool useKnownTrans = false; //prefer known transcripts inference
  
  bool lengthNormRegularized = false; // normalize regularization parameter by length (prefer longer isoforms)
  
  bool verbose = false;
 

//column generation
  bool cov_expl_by_opt = true; //column generation guided by unexplained covers. Unexplained (initially) by opt (true) or candidates (false)
  bool greedy_expl_uncov = false; //iteratively update explained covers during cg
  int max_nof_relaxed_edges = 1; //max number of uncovered junctions allowed to use to explain new covers
  bool explainNewCover = true; //in each iteration an unexplained cover has to be explained
  UInt unexpl_cov_bound = 0; //only shoot at unexplained covers with intensity >= x
  int unexpl_cov_sum_bound = 0; // sum of intensities of newly explained covers must exceed be >= x
  double cg_regWeight = 1.; //make transcripts from cg more expensive for second glmnet
  double scale_lambda_cg = 1.; //make transcrits cheaper during CG
}


